您的位置:首页 > 其它

LeetCode-Two Sum

2014-09-05 22:26 260 查看
题目:https://oj.leetcode.com/problems/two-sum/

Given an array of integers, find two numbers such that they add up to a specific target number.

The function twoSum should return indices of the two numbers such that they add up to the target, where index1 must be less than index2. Please note that your returned answers (both index1 and index2) are not zero-based.

You may assume that each input would have exactly one solution.

Input: numbers={2, 7, 11, 15}, target=9

Output: index1=1, index2=2

分析:

方法1:暴力,复杂度O(n2),会超时

方法2:hash。用一个哈希表,存储每个数对应的下标,复杂度O(n).

方法3:先排序,然后左右夹逼,排序O(n log n),左右夹逼O(n),最终O(n log n)。但是注意,这题需要返回的是下标,而不是数字本身,因此这个方法行不通。
源码:Java版本

算法分析:用一个哈希表,存储每个数对应的下标。时间复杂度O(n),空间复杂度O(n)

public class Solution {
    public int[] twoSum(int[] numbers, int target) {
        Map<Integer,Integer> map=new HashMap<>();
        for(int i=0;i<numbers.length;i++) {
            map.put(numbers[i],i+1);
        }
        
        int[] result=new int[2];
        int other;
        for(int i=0;i<numbers.length;i++) {
            other=target-numbers[i];
            if(map.containsKey(other) && i+1<map.get(other)) {
                result[0]=i+1;
                result[1]=map.get(other);
                break;
            }
        }
        return result;
    }
}
内容来自用户分享和网络整理,不保证内容的准确性,如有侵权内容,可联系管理员处理 点击这里给我发消息
标签: